package zustand;

public class StateEmpty extends AbstractState {

private Machine mach;

  public StateEmpty(Machine ma) {
    mach=ma;
  }

  public void show_state() {
    System.out.println("state: No Card!!!!");
  }

  public void add_money(int m) {
    System.out.println("No Card, rejecting " + (int) m + ".");
  }

  public boolean insert_card(Card c) {
    StateCard new_state = new StateCard(mach, c);
    mach.set_state(new_state);
    return true;
  }

}